#!/bin/bash
#
# Find all the ssh config files in ~/.ssh/config.d and print a menu that shows username@hostname. 
# The script will attempt to connect to the selected item.

bold=$(tput bold)
normal=$(tput sgr0)

options=()

echo "Showing hosts found in ~/.ssh/config.d:"
echo

for file in ${HOME}/.ssh/config.d/*; do

    shopt -s nocasematch
    for word in $(grep -i "^[^#\S]*Host\(name\)\?" "${file}" | paste -s -); do
      case "$word" in
        "Host")
          type=host
          ;;
        "Hostname")
          type=hostname
          ;;
        *)
          case "$type" in
            "host")
              host=$word
            ;;
            "hostname")
                hostname=$word

                user=$(grep -i "^[^#\S]*User\?" "${file}" | paste -s - | xargs | cut -c 6-)

#                echo "${host} ${bold}(${user}@${hostname})${normal}"

#                options+=("${user}@${hostname}")
                options+=("${host}")

              unset host hostname
            ;;
          esac
      esac
    done

done

COLUMNS=1
PS3='Enter # to Connect: '
select opt in "${options[@]}"
do
  echo "Connecting to ${opt}"...
  ssh ${opt}
  break
done
